dojo.provide("com.ibm.skins.Thin.bspaceSkin");

dojo.require("com.ibm.skins.Thin.skin");

dojo.declare("com.ibm.skins.Thin.bspaceSkin", com.ibm.skins.Thin.skin, {

	resizedWithTitleBar: false,
	
	constructor: function(id, node) {

		if (dojo.hasClass(node,'bspace-skin')) 
			return;
		dojo.addClass(node,'bspace-skin');

		var bspaceContextRoot = com.ibm.bspace.common.util.widget.BSpaceExtension.getBSpaceServerEndpointURL();
		dojo.registerModulePath("bspaceColumnLayout", bspaceContextRoot + "iWidget/widgets/system/columnLayout");
		dojo.requireLocalization("bspaceColumnLayout", "columnLayoutResources", dojo.locale, window.bspaceSupportedLocales);
		var columnLayoutResources = dojo.i18n.getLocalization("bspaceColumnLayout", "columnLayoutResources");

	    dojo.registerModulePath("widgetNLS", bspaceContextRoot + "iWidget/com/ibm/mm/builder");	
		dojo.requireLocalization("widgetNLS", "coreWidgetsStr", dojo.locale, window.bspaceSupportedLocales);
		var coreWidgetsStr = dojo.i18n.getLocalization("widgetNLS", "coreWidgetsStr"); 		

		var title = dojo.query(".decoration-titlebar", node)[0];
        if (title) {
	        this.connect(title,"mouseover","onMouseOver");
	        this.connect(title,"mouseout","onMouseOut");
        }
	var widgetName = "";
        var localizedContext = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
	var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
	var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
	var runtimeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel();
	var currentPage = runtimeModel.getCurrentPage();
	var layoutModel = navModel.getLayoutModel(currentPage);
	var layoutControl = layoutModel.find(id).start();
	if (layoutControl) {
	    widgetName = localizedContext.getTitle(layoutControl);
	    if (!widgetName) {
	        var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start();
		var widgetDefinition = widgetModel.getWidgetDefinitionByWindow(widgetWindow).start();
		widgetName = localizedContext.getTitle(widgetDefinition);
	    }
	}
        var max = dojo.query(".bspaceMaxIcon", node)[0];
        if(max) {
        	dijit.setWaiRole(max,"button");
        	max.title = columnLayoutResources.maximizeWidgetTitle;
        	var ariaLabelMax = max.title+" "+ widgetName;
        	dojo.attr(max,"aria-label",ariaLabelMax);
	        this.connect(max,"click","maximizeWidget");
        }
        var rest = dojo.query(".bspaceRestoreIcon", node)[0];
        if (rest) {
        	dijit.setWaiRole(rest,"button");
        	rest.title = columnLayoutResources.restoreWidgetTitle;
        	var ariaLabelRestore = rest.title+" for "+ widgetName;
        	dojo.attr(rest,"aria-label",ariaLabelRestore);
	        this.connect(rest,"click","restoreWidget");
		}
        var min = dojo.query(".bspaceMinIcon", node)[0];
        if(min) {
        	dijit.setWaiRole(min,"button");
        	min.title = columnLayoutResources.minimizeWidgetTitle;
            var ariaLabelMin = min.title+" "+widgetName;
        	dojo.attr(min,"aria-label",ariaLabelMin);
	        this.connect(min,"click","minimizeWidget");
        }
        var menu = dojo.query(".decoration-contextMenuAction", node)[0];
        if(menu) {
        	dijit.setWaiRole(menu,"button");
        	menu.title = coreWidgetsStr.I_SKIN_EDIT_ICON_TITLE;
            var ariaLabelMenu = menu.title+" for "+widgetName;
        	dojo.attr(menu,"aria-label",ariaLabelMenu);
        }
        var showTitle = dojo.query(".ibmShowTitleBarLink", node)[0];
        if(showTitle) {
        	showTitle.title = coreWidgetsStr.I_SKIN_SHOW_TITLE;
        	var alt = dojo.query(".lotusAltText", showTitle)[0];
        	if (alt) {
        		alt.innerHTML = coreWidgetsStr.I_SKIN_SHOW_TITLE_ALT;
        	}
        	dijit.setWaiRole(showTitle,"button");
        }
        var labelShowTitle = dojo.byId("labelShowTitleBarLink");
        if (labelShowTitle) {
        	labelShowTitle.innerHTML = coreWidgetsStr.I_SKIN_SHOW_TITLE;
        }
        var hideTitle = dojo.query(".ibmHideTitleBarLink", node)[0];
        if(hideTitle) {
        	hideTitle.title = coreWidgetsStr.I_SKIN_HIDE_TITLE;
        	var alt = dojo.query(".lotusAltText", hideTitle)[0];
        	if (alt) {
        		alt.innerHTML = coreWidgetsStr.I_SKIN_HIDE_TITLE_ALT;
        	}
        	dijit.setWaiRole(hideTitle,"button");
        }
        var labelHideTitle = dojo.byId("labelHideTitleBarLink");
        if (labelHideTitle) {
        	labelHideTitle.innerHTML = coreWidgetsStr.I_SKIN_HIDE_TITLE;
        }
        
		if (!this.resizerInited) {
			this.createWidgetResizeHandle(id,node);
		}

        var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
    	this.resizeWidgetHandler = evtSvc.subscribeEvent("com.ibm.mashups.builder.resizeWidget", null, dojo.hitch(this, 'onResizeWidget'));

    },

    onMouseOver: function(evt) {
    	var title = dojo.query(".bspaceSkinTopEdgeAndTitleFill", this.root)[0];
    	if (title) {
    		dojo.addClass(title.parentNode,"bspaceOverEditBar");
    	}
    },

    onMouseOut: function(evt) {
    	var title = dojo.query(".bspaceSkinTopEdgeAndTitleFill", this.root)[0];
    	if (title) {
    		dojo.removeClass(title.parentNode,"bspaceOverEditBar");
    	}
    },

	getWidgetState: function() {
		var state = "normal";
		if (dojo.hasClass(this.root,"ibm-maximized")) {
			state = "max";
		}
		if (dojo.hasClass(this.root,"ibm-minimized")) {
			state = "min";
		}
		return state;
	},
	
	notifyChangeWidgetState: function(oldState,newState) {
		var stop = false;
		var iContext = window['_'+this.id+'_iContext'];
		if (typeof iContext.iScope().onChangeWidgetState == 'function') {
			stop = iContext.iScope().onChangeWidgetState(oldState,newState);
		}
		return stop;
	},

    maximizeWidget: function() {
		var state = this.getWidgetState();
		if (this.notifyChangeWidgetState(state,"max")) {
			return;
		}
    	var metadata = {
    		newWindowState: "maximize",
    		event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE
    	};
    	com.ibm.pb.contextMenu.sharedActions.changeWindowState(this.id,null,metadata,null);
        var rest = dojo.query(".bspaceRestoreIcon", this.root)[0];
        if (rest) {
        	rest.focus();
		}
    },

    minimizeWidget: function() {
		var state = this.getWidgetState();
		if (this.notifyChangeWidgetState(state,"min")) {
			return;
		}
    	var metadata = {
    		newWindowState: "minimize",
    		event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE
    	};
    	com.ibm.pb.contextMenu.sharedActions.changeWindowState(this.id,null,metadata,null);
        var rest = dojo.query(".bspaceRestoreIcon", this.root)[0];
        if (rest) {
        	rest.focus();
		}
    },

    restoreWidget: function() {
		var state = this.getWidgetState();
		if (this.notifyChangeWidgetState(state,"normal")) {
			return;
		}
    	var metadata = {
    		newWindowState: "normal",
    		event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE
    	};
    	com.ibm.pb.contextMenu.sharedActions.changeWindowState(this.id,null,metadata,null);
        var min = dojo.query(".bspaceMinIcon", this.root)[0];
        if (min) {
        	min.focus();
		}
	},

	destroy: function() {
		if (this.resizeWidgetHandler) {
	   		var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
	   		this.resizeWidgetHandler = evtSvc.unsubscribeEvent(this.resizeWidgetHandler,null);
		}
		this.inherited(arguments);
	},
	
	showTitleBar: function(controlDiv, showLink, node) {
		this.inherited(arguments);
		this.resizedWithTitleBar = false;
	},
	
	hideTitleBar: function(controlDiv, node) {
		this.inherited(arguments);
		if (this.resizedWithTitleBar) {
			this.loadWidgetHeight(this.root);
		}
	},

	onResizeWidget: function(evt) {
		// make sure this message is for this widget 
		if (evt.widgetId == this.id) {
			// if we are in view mode, we need to save the new size in the personalized data
			if (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() != "edit") {
				// Clear dirty flag after resize processing finishes since this is not edit mode
				window.setTimeout(this._resetDirtyFlag,100);
			}
			// if the title bar is currently showing, set a flag to indicate that we 
			// will need to fix up the height when the title bar is hidden again
			var controlDiv = dojo.query(".lotusWidget2", this.root)[0];
			if (controlDiv && !dojo.hasClass(controlDiv,"ibmHideTitleBar")) {
				this.resizedWithTitleBar = true;
			}
		}
	},

	// Business Space moved the ibmToggleTitleBar control above the widget
	// so it should not be included in any height adjustments
	_getMarginHeight: function(node) {
		var h = 0;
		if (!dojo.hasClass(node,'ibmToggleTitleBar')) {
			h = this.inherited(arguments);
		}
		return h;
	},

	loadWidgetHeight: function(parentNode){
		if (!dojo.hasClass(parentNode,'ibm-maximized')) {
			this.inherited(arguments);
		}
	},
	
	_resetDirtyFlag: function() {
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
	}
	
	
});
