// Licensed Materials - Property of IBM
// 5724-M22, 5724-M23, 5724-M24, 5724-L01, 5724-R31
// (C) Copyright IBM Corporation 2011, 2013. 
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.themes.bspaceTheme.common");

//cs: here we programmatically add a link element in order to make use of the 'themeRootURI' javascript variable
var linkElement = document.createElement("link");
linkElement.rel = "stylesheet";
linkElement.type = "text/css";
linkElement.href = ibmCfg.themeConfig.themeRootURI + "/theme.css";
var headElement= document.getElementsByTagName("head")[0];  
headElement.appendChild(linkElement);
// end create link element

//bp: fix up lang and bidi values that mashups handles with nls versions of theme
var locale = djConfig.locale;
if ((locale.length > 2) && (locale.charAt(2) == '-')) {
	locale = locale.substring(0,2) + '_' + locale.substring(3).toUpperCase(); 
}
document.documentElement.setAttribute('lang',locale);
document.documentElement.setAttribute('xml:lang',locale);
if ((locale == 'ar') || (locale == 'iw') || (locale == 'he')) {
	document.body.setAttribute('dir','rtl');
}

// bp: define a variable for the supported locales so that we have a common
// location that the code can reference to restrict which locales are
// searched for nls files within the core Business Space code.  
window.bspaceSupportedLocales = "ar,cs,de,el,es,fr,he,hu,it,iw,ja,ko,pl,pt,pt-br,ro,ru,tr,zh,zh-tw,da,fi,nb,sk,sv,nl,no";

// rt: register BSpace theme bundles now
var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
var co = cs.getConfigObject(com.ibm.mashups.enabler.services.ConfigConstants.ENDPOINT_CONFIG_PROVIDER);
var serverEndpointURL = co.getValue("{com.ibm.bspace}bspaceServerRootId.url");
dojo.registerModulePath("com.ibm.bspace.bundles", serverEndpointURL + "/com/ibm/bspace/bundles");

// bp: run the following logic after the PageBuilder2 theme is initialized
com.ibm.themes.bspaceTheme.common.init = function() {
	com.ibm.themes.bspaceTheme.resizeCoverScrollListener = false;
	com.ibm.themes.bspaceTheme.showResizeCover = function() {
		var div = document.createElement('div');
		div.id = 'bspaceSizingCover';
		div.style.position = 'absolute';
		div.style.top = document.documentElement.scrollTop + 'px';
		div.style.left = '0px';
		div.style.width = '100%';
		div.style.height = '100%';
		if (dojo.isIE) {
			div.style.backgroundColor = '#f0f0f0';
			div.style.opacity = 0.1;
			div.style.filter = 'alpha(opacity=1)';
		}
		document.body.appendChild(div);
		if (!com.ibm.themes.bspaceTheme.resizeCoverScrollListener) {
			com.ibm.themes.bspaceTheme.resizeCoverScrollListener = true;
		    if (document.documentElement.addEventListener) {
		        document.documentElement.addEventListener('scroll',com.ibm.themes.bspaceTheme.scrollResizeCover,false);
		    } else if (document.documentElement.attachEvent) {
		        document.documentElement.attachEvent('onscroll',com.ibm.themes.bspaceTheme.scrollResizeCover);
		    }   
		}
	};
	com.ibm.themes.bspaceTheme.hideResizeCover = function() {
		var div = dojo.byId('bspaceSizingCover');
		if (div) {
			document.body.removeChild(div);
			delete div;
		}
		if (com.ibm.themes.bspaceTheme.resizeCoverScrollListener) {
			com.ibm.themes.bspaceTheme.resizeCoverScrollListener = false;
		    if (document.documentElement.removeEventListener) {
		        document.documentElement.removeEventListener('scroll',com.ibm.themes.bspaceTheme.scrollResizeCover,false);
		    } else if (document.documentElement.detachEvent) {
		        document.documentElement.detachEvent('onscroll',com.ibm.themes.bspaceTheme.scrollResizeCover);
		    }   
		}
	};
	com.ibm.themes.bspaceTheme.scrollResizeCover = function() {
		var div = dojo.byId('bspaceSizingCover');
		if (div) {
			div.style.top = document.documentElement.scrollTop + 'px';
		}
	};
	dojo.extend(com.ibm.pb.layout.resize.WidgetResizer, {
		_mashupsBeginSizing: com.ibm.pb.layout.resize.WidgetResizer.prototype._beginSizing,
		_mashupsEndSizing: com.ibm.pb.layout.resize.WidgetResizer.prototype._endSizing,
		_beginSizing: function(e) {
			this._mashupsBeginSizing(e);
			com.ibm.themes.bspaceTheme.showResizeCover();
			var controlNode = com.ibm.pb.layout.LayoutParser.findById(this.controlId);
			if (controlNode.style.height) {
				this.controlStyle.height = controlNode.style.height;
			} 
		},
		_endSizing: function(e) {
			com.ibm.themes.bspaceTheme.hideResizeCover();
			this._mashupsEndSizing(e);
		}
	});
	dojo.extend(com.ibm.pb.layout.resize.ContainerResizer, {
		_mashupsBeginSizing: com.ibm.pb.layout.resize.ContainerResizer.prototype._beginSizing,
		_mashupsEndSizing: com.ibm.pb.layout.resize.ContainerResizer.prototype._endSizing,
		_beginSizing: function(e) {
			this._mashupsBeginSizing(e);
			com.ibm.themes.bspaceTheme.showResizeCover();
		},
		_endSizing: function(e) {
			com.ibm.themes.bspaceTheme.hideResizeCover();
			this._mashupsEndSizing(e);
		},
		onEndSizing: function(styles) {
			// if we are in view mode, we need to save the new size in the personalized data
			if (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() != "edit") {				
				var leftNodeId = this.leftNodeId;
				var rightNodeId = this.rightNodeId;
				var leftWidth = styles.left.width;
				var rightWidth = styles.right.width; 
				// Clear dirty flag since this is not edit mode
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
			}
		}
	});
	// modify the default widget wrapper to allow the config, edit,
	// and personalize modes to be displayed in a dialog
	com.ibm.themes.bspaceTheme.common.editModeDialog = null;
	com.ibm.themes.bspaceTheme.common.editModeWidgetId = null;
	com.ibm.themes.bspaceTheme.common.editModeDialogClosed = function() {
        var variableName = "_" + com.ibm.themes.bspaceTheme.common.editModeWidgetId + "_" + "iContext";
        var iContext = dojo.global[variableName]
		iContext.iEvents.fireEvent("onModeChanged",null,"{newMode:'view'}");
	};
	dojo.addOnUnload(function () {
		if (com.ibm.themes.bspaceTheme.common.editModeDialog) {
			com.ibm.themes.bspaceTheme.common.editModeDialog.destroy();
			com.ibm.themes.bspaceTheme.common.editModeDialog = null;
		}
	});
	dojo.extend(com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl, {
		_isDialogSupportedForMode: function(mode) {
			var rc = false;
			if (mode == 'edit') rc = true;
			if (mode == 'config') rc = true;
			if (mode == 'personalize') rc = true;
			if (rc) {
				// defect 46734
				// if the widget does not have a title span, then we do not have a way
				// to get a title to use when showing the mode correctly as a dialog
				var titleSpan = dojo.byId('title.'+this.id);
				if (!titleSpan) {
					rc = false;
				}
			}
			return rc;
		},
		_handleMashupsModeChange: com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl.prototype._handleModeChange,
		_handleMashupsOnModeEvent: com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl.prototype._handleOnModeEvent,
		_handleMashupsEventInternal: com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl.prototype._handleEventInternal,
		_handleModeChange: function(iEvent) {
			var payload = iEvent.payload;
			var newMode = null;
			if (payload) {
				newMode = payload.newMode;
			}
			if (this._isDialogSupportedForMode(newMode)) {
				dojo.addClass(this.rootElement,'showWidgetView');
				dojo.addClass(this.rootElement,'hideWidgetEdit');
				dojo.addClass(this.rootElement,'hideWidgetConfig');
				dojo.addClass(this.rootElement,'hideWidgetPersonalize');
			}
			this._handleMashupsModeChange(iEvent);
			if (!this._isDialogSupportedForMode(newMode)) {
				dojo.removeClass(this.rootElement,'showWidgetView');
				dojo.removeClass(this.rootElement,'hideWidgetEdit');
				dojo.removeClass(this.rootElement,'hideWidgetConfig');
				dojo.removeClass(this.rootElement,'hideWidgetPersonalize');
			}
		},
		_handleOnModeEvent: function(mode,oldMode) {
			if (this._editModeDialog) {
				this._editModeDialogCleanup(oldMode);
			}
			this._handleMashupsOnModeEvent(mode,oldMode);
			if (this._isDialogSupportedForMode(mode)) {
				this._showEditModeDialog(mode);
			}
		},
		_editModeDialog: null,
		_showEditModeDialog: function(mode) {
			var titleSpan = dojo.byId('title.'+this.id);
			var titleText = titleSpan.innerHTML;
			if (com.ibm.themes.bspaceTheme.common.editModeDialog &&
			   (com.ibm.themes.bspaceTheme.common.editModeWidgetId != this.id)) {
				com.ibm.themes.bspaceTheme.common.editModeDialog.destroy();
				com.ibm.themes.bspaceTheme.common.editModeDialog = null;
			}
			com.ibm.themes.bspaceTheme.common.editModeWidgetId = this.id;
			if (com.ibm.themes.bspaceTheme.common.editModeDialog) {
				this._editModeDialog = com.ibm.themes.bspaceTheme.common.editModeDialog;
				this._editModeDialog.setTitle(titleText);
			} else {
				this._editModeDialog = new com.ibm.mm.builder.widget.CustomDialog({
					id: "com_ibm_bspace_edit_dialog",
	            	type: "config",
	            	title: titleText,
	            	needModeSwitch: false,
	            	belongId: this.id,
	            	containerBackgroundColor: "white",
					hasRightBottomResizer: false,
					closeCallback: com.ibm.themes.bspaceTheme.common.editModeDialogClosed
				});
				com.ibm.themes.bspaceTheme.common.editModeDialog = this._editModeDialog;
			}
			var editRootNode = this.windowManager[mode].root;			
			this._editModeDialog.containerNode.appendChild(editRootNode);
	        this._editModeDialog.show();
		},
		_editModeDialogCleanup: function(oldMode) {
			var editRootNode = this.windowManager[oldMode].root;
			this.rootElement.appendChild(editRootNode);
			this._editModeDialog.hide();
			this._editModeDialog = null;
		}
	});
	// modify the decoration manager to automatically call _addStyleFilter
	// when a LayoutFilter is registered with the decoration manager 
	com.ibm.pb.decorations.DECORATION_MANAGER.mashupsRegisterLayout = com.ibm.pb.decorations.DECORATION_MANAGER.registerLayout; 
	com.ibm.pb.decorations.DECORATION_MANAGER.registerLayout = function(node) {
			this.mashupsRegisterLayout(node);
			var name = com.ibm.domUtilities.textContent(node);
			if (name == 'com.ibm.pb.decorations.LayoutFilters') {
				// filter is the last one on the array
				var obj = this._layoutComps[this._layoutComps.length-1].obj;
				if (obj && obj._addStyleFilter) {
					obj._addStyleFilter();					
				}
			}
	};
	// mashups container resizers are always set to the height of the layout
	// node when they are created.  this causes problems when container heights
	// change and when containers are placed above/below other containers.
	// to fix this, we are using a timer to set the height of the resizers
	// based on the nodes to either side of the resizer
	dojo.extend(com.ibm.pb.decorations.LayoutResizers, {
		_mashupsProcessContainer: com.ibm.pb.decorations.LayoutResizers.prototype.processContainer,
		processContainer: function(id,node) {
			this._mashupsProcessContainer(id,node);
			var resizer = this.components[id];
			if (resizer) {
				resizer.fixHeight();
			}
		}
	});
	dojo.extend(com.ibm.pb.layout.resize.ContainerResizer, {
		intervalHandle: null,
		fixHeight: function() {
			if (this.domNode && !this.intervalHandle) {
				this.intervalHandle = window.setInterval(dojo.hitch(this,'fixHeight'),500);
			}
			if (this.domNode && this.domNode.previousSibling && this.domNode.nextSibling) {
				var h = this.domNode.previousSibling.offsetHeight;
				if (h < this.domNode.nextSibling.offsetHeight) {
					h = this.domNode.nextSibling.offsetHeight;
				}
				if (this.domNode.offsetHeight != h) {
					this.domNode.style.height = h + 'px';
				}
			}
			if (this.intervalHandle && !this.domNode) {
				window.clearInterval(this.intervalHandle);
				this.intervalHandle = null;
			}
		}
	});
	// get the initial width of the lotusMain container so we can
	// check for size changes later
	com.ibm.themes.bspaceTheme.common.width = document.body.offsetWidth;
	if (dojo.byId('lotusMain')) {
		com.ibm.themes.bspaceTheme.common.width = dojo.byId('lotusMain').offsetWidth;
	}
	// when the browser size has changed, send onSizeChanged to any
	// widgets inside of column containers
	com.ibm.themes.bspaceTheme.common.handleWidthChanged = function() {
		com.ibm.themes.bspaceTheme.common.timeout = null;
		var lotusMain = dojo.byId('lotusMain');
		if (lotusMain) {
			var width = lotusMain.offsetWidth;
			if (com.ibm.themes.bspaceTheme.common.width != width) {
				com.ibm.themes.bspaceTheme.common.width = width;				
	            var cols = dojo.query(".ibmDndColumn", lotusMain);
	            for (var i=0; i<cols.length; i++){
	            	var nodes = dojo.query(".iw-iWidget", cols[i]);
	            	for (var j=0; j<nodes.length; j++) {
	            		var widgetId = nodes[j].id;
	            		var box = dojo.contentBox(nodes[j].parentNode);
		            	var payload = { "newWidth": box.w, "newHeight": box.h };
		            	var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		            	eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgetId,payload);
	            	}
	            }
			}
		}
	};
	// connect to the window resize event so we know when the
	// browser window changes.  use a timer so that we only resize
	// widgets after 1 second since the last sizing movement
	if (dojo.isIE) {
		window.attachEvent('onresize',function() {
			if (com.ibm.themes.bspaceTheme.common.timeout) {
				window.clearTimeout(com.ibm.themes.bspaceTheme.common.timeout);
			}
			com.ibm.themes.bspaceTheme.common.timeout = window.setTimeout(com.ibm.themes.bspaceTheme.common.handleWidthChanged,1000);
		});
	} else {
		dojo.connect(window,'resize',function() {
			if (com.ibm.themes.bspaceTheme.common.timeout) {
				window.clearTimeout(com.ibm.themes.bspaceTheme.common.timeout);
			}
			com.ibm.themes.bspaceTheme.common.timeout = window.setTimeout(com.ibm.themes.bspaceTheme.common.handleWidthChanged,1000);
		});
	}
	dojo.extend(com.ibm.pb.control.RenderingController, {
		_mashupsMaximizeWidget: com.ibm.pb.control.RenderingController.prototype._maximizeWidget,
		_mashupsProcessMaximize: com.ibm.pb.control.RenderingController.prototype._processMaximize,
		_mashupsRemoveMaximize: com.ibm.pb.control.RenderingController.prototype._removeMaximize,
		_mashupsGetWindowHeight: com.ibm.pb.control.RenderingController.prototype._getWindowHeight,
		_mashupsProcessControls: com.ibm.pb.control.RenderingController.prototype.processControls,
		// if a widget is maximized when the page is loaded, the correct size may not
		// be available, so we need to check for this condition and fix up the maxWidgetStore
		// values 
		_maximizeWidget: function(currentWidget, keepOldWidgetHeight) {
			var fixBodyHeight = false;
			var widgetBody = dojo.query(".lotusWidgetBody", currentWidget)[0];
			if (keepOldWidgetHeight) {
				var controlHeight = currentWidget.style.height;
				var bodyHeight = widgetBody.style.height;
				if (!bodyHeight || (bodyHeight == 'auto')) {
					var bodyBox = dojo.contentBox(widgetBody);
					bodyHeight = bodyBox.h+'px';
					fixBodyHeight = true;
					if ((bodyBox.h == 0) && controlHeight && (controlHeight != 'auto')) {
						bodyHeight = (parseInt(controlHeight)-dojo.contentBox(currentWidget).h)+'px';
						fixBodyHeight = false;
					}
				}
				if (!controlHeight || (controlHeight=='auto')) {
					controlHeight = dojo.contentBox(currentWidget).h+'px';
				}
				this.maxWidgetStore = {controlHeight: controlHeight, bodyHeight: bodyHeight};
			}
			this._insideMaximizeWidget = true;
			this._mashupsMaximizeWidget(currentWidget, false);
			this._insideMaximizeWidget = false;
			widgetBody.style.minHeight = widgetBody.style.height;
			if (fixBodyHeight) {
				this.maxWidgetStore = {controlHeight: 'auto', bodyHeight: 'auto'};
			}
			this.layoutContainers.style.height = currentWidget.style.height;
			
		},
		// when a widget is maximized, we need to change the styles on the lotusMain
		// container
		_processMaximize: function(currentWidget, container){
			dojo.addClass(dojo.byId('lotusMain'),'bspace-maximized');
			this._mashupsProcessMaximize(currentWidget, container);
		},
		_removeMaximize: function(widget){
			var widgetBody = dojo.query(".lotusWidgetBody", widget)[0];
			widgetBody.style.minHeight = '';
			dojo.removeClass(dojo.byId('lotusMain'),'bspace-maximized');
			this._mashupsRemoveMaximize(widget);
		},
		processControls: function(node,addMaxBuffer){
			dojo.removeClass(dojo.byId('lotusMain'),'bspace-maximized');
			this._mashupsProcessControls(node,addMaxBuffer);
		},
		// when doing size calculations for a maximized widget, remove the footer height (27px)
		_getWindowHeight: function() {
			h = this._mashupsGetWindowHeight();
			if (this._insideMaximizeWidget) {
				h = h - 27;
			}
			return h;
		}
	});
	var bspaceContextRoot = com.ibm.bspace.common.util.widget.BSpaceExtension.getBSpaceServerEndpointURL();
	dojo.registerModulePath("com.ibm.bspace.common.util.ui", bspaceContextRoot + "com/ibm/bspace/common/util/ui");
	dojo.require('com.ibm.bspace.common.util.ui.Helper');
	com.ibm.themes.bspaceTheme.mashupsDisplayEmbedDialog = com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog;
	com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog = function(id, type, widgetType) {
		com.ibm.themes.bspaceTheme.mashupsDisplayEmbedDialog(id,type,widgetType);
		if (type == 'page') {
			var txt = dojo.query('.embedPgDlgDesp')[0];
			if (txt) {
				com.ibm.bspace.common.util.ui.Helper.screenReaderReadText(txt.innerHTML);
			}
		}
	};
	// defect 45903
	// when trying to switch to a space that has pages, but none that the
	// current user can access, we get a status of 400 and a null resource.
	// watch for this condition and call the callback instead of allowing
	// the default mashups processing which will throw exceptions
	dojo.extend(com.ibm.pb.tree.DFSTraversal,{
		_mashupsVisitChildren: com.ibm.pb.tree.DFSTraversal.prototype._visitChildren,
		_visitChildren: function(resource, status, dfdParams) {
			if ((status == 400) && (resource == null)){
				dfdParams.callback(dfdParams.params.list); 
			} else {
				this._mashupsVisitChildren(resource,status,dfdParams);
			}
		}
	});
	// defect 46264
	// there is a bug when using Adobe Flash/Flex with IE that causes the
	// document title to be corrupted.  this is a work-around that watches
	// for changes to the document title and fixes the title if it appears
	// to be corrupted
	if (dojo.isIE) {
		document.attachEvent('onpropertychange',function() {
		    if (window.event.propertyName == 'title') {
		    	if (document.title.indexOf("#pid") != -1) {
		    		page = com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
		    		if (page) {
		    			// use unescaped title
		    			var title = com.ibm.mm.builder.utils.enablerUtil.getUnescapedNodeTitle(page, dojo.locale);
		    			// check if the title is already correct to avoid inifinite loop case
		    			if (document.title != title) {
		    				document.title = title;
		    			}
		    		}
		    	}
		    } 
		});
	}
	// special iPad processing
	if (dojo.isSafari && navigator.userAgent.indexOf('iPad') != -1) {
		// add iPad class name to document element
		dojo.addClass(document.body,'iPad');
		// move the dj_history iframe because it causes the window to display incorrectly
		var dj_history = document.getElementById('dj_history');
		if (dj_history) {
			dj_history.style.left = '0px';
			dj_history.style.right = '';
			dj_history.style.top = '0px';
			dj_history.style.bottom = '';
		}
		// remove import/export actions in menus
		com.ibm.mm.builder.model.ContextMenuImpl.prototype.mashupsGetContextMenu = com.ibm.mm.builder.model.ContextMenuImpl.prototype.getContextMenu;
		com.ibm.mm.builder.model.ContextMenuImpl.prototype.getContextMenu = function(contextMenuId,targetResourceId,targetResourceType,someObject) {
			var results = this.mashupsGetContextMenu(contextMenuId,targetResourceId,targetResourceType,someObject);
			if ((contextMenuId == 'ContextMenu.SpaceManager.ActionBar') ||
					(contextMenuId == 'ContextMenu.SpaceManager.Space') ||
					(contextMenuId == 'ContextMenu.SpaceManager.Page')) {
				var tmp = new Array();
				for (i=0; i<results.length; i++) {
					var id = results[i].id;
					if ((id != 'smImportSpace') && (id != 'smImportPage') && (id != 'smExportSpace') && (id != 'smExportPage')) {
						tmp[tmp.length] = results[i];
					} 
				}
				results = tmp;
			}
			if (contextMenuId == 'ContextMenu.TemplateManager.Template') {
				var tmp = new Array();
				for (i=0; i<results.length; i++) {
					var ord = results[i].ordinal;
					if (ord != 0) { // export 
						tmp[tmp.length] = results[i];
					} 
				}
				results = tmp;
			}
			return results;
		}
		// The dialog close button does not get the click events because
		// they are being "stolen" by the dojo.dnd.Movable code (used to  
		// allow the dialog to be moved by dragging the title bar).
		// To fix this, we are moving the button to be outside the title
		// div (but making it look like it's still part of the title)
		com.ibm.mm.builder.widget.CustomDialog.prototype.mashupsShow = com.ibm.mm.builder.widget.CustomDialog.prototype.show; 
		com.ibm.mm.builder.widget.CustomDialog.prototype.show = function(){
			if (!this.ipadfix) {
				if (dojo._isBodyLtr()) {
					this.titleBar.style.marginRight = '25px';
				} else {
					this.titleBar.style.marginLeft = '25px';
				}
				var div = document.createElement('div');
				div.className = 'dialog_titlebar';
				div.style.position = 'absolute';
				div.style.top ='1px';
				div.style.width = '15px';
				if (dojo._isBodyLtr) {				
					div.style.right = '0px';
				} else {
					div.style.left = '0px';
				}
				this.dialogNode.appendChild(div);
				this.closeButtonNode.parentNode.removeChild(this.closeButtonNode);
				div.appendChild(this.closeButtonNode);
				this.ipadfix = true;
			}
        	this.mashupsShow();
		}
	}
	// defect 47681: if we are switching spaces, make sure that
	// the last visisted page is not a global page
	dojo.extend(com.ibm.pb.control.NavigationController, {
		mashupsSwitchSpaceHandler: com.ibm.pb.control.NavigationController.prototype.switchSpaceHandler,
		switchSpaceHandler: function(spaceId, semantics) {
			if (spaceId) {
				var pageAcc = this.accFactory.getPageAccessor(this.nsm, spaceId);
				var pageId = pageAcc.getPageID();
				if (pageId) {
					var firstPageId = com.ibm.mm.builder.utils.pageUtil.getFirstPageInSpace(spaceId);
					if (firstPageId && firstPageId.length > 0) {
						var pageParentId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(pageId);
						var currentParentId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(firstPageId);
						if (currentParentId && pageParentId != currentParentId) {
							pageAcc.setPageID(firstPageId);
						}
					} else {
						pageAcc.setPageID("");
					}
				}
			}
			this.mashupsSwitchSpaceHandler(spaceId, semantics);
		}
	});
	// defect 48247: IE9 throws an exception is the document being use to create
	// the attribute node is not the same document that owns the element
	com.ibm.mm.enabler.utils.Dom._mashupsSetAttributeWithNS = com.ibm.mm.enabler.utils.Dom.setAttributeWithNS;
    com.ibm.mm.enabler.utils.Dom.setAttributeWithNS = function(dom, element, attName, localAttName, nsUri, value){
        if ((dojo.isIE > 8) && element.ownerDocument) {
    	   	com.ibm.mm.enabler.utils.Dom._mashupsSetAttributeWithNS(element.ownerDocument,element,attName,localAttName,nsUri,value);
	       } else {
        	com.ibm.mm.enabler.utils.Dom._mashupsSetAttributeWithNS(dom,element,attName,localAttName,nsUri,value);
    	}		
	};
	// defect 54063: if we change the skin for a maximized widget it causes
	// lots of problems since the skin code does not know about the maximized
	// buffer area.  to fix this we will restore a widget if it's maximized 
	// before changing the skin and then maximizing it back after the skin
	// change is complete.
	com.ibm.themes.bspaceTheme.delayedMaximize = null; 
	com.ibm.themes.bspaceTheme.performDelayedMaximize = function() {
		var widgetId = com.ibm.themes.bspaceTheme.delayedMaximize;
		if (widgetId) {
			var metadata = new Object();
			metadata.newWindowState ="maximize";
			metadata.event = com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE;
			com.ibm.pb.contextMenu.sharedActions.changeWindowState(widgetId, null, metadata, null);
			var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
			evtSvc.unsubscribeEvent(com.ibm.themes.bspaceTheme.delayedMaxmizeSub); 
			com.ibm.themes.bspaceTheme.delayedMaximize = null;
			com.ibm.themes.bspaceTheme.delayedMaximizeSub = null;
		}					
	};
	dojo.extend(com.ibm.pb.decorations.MashupSkinItems, {
		_mashupsSwitchToSkin: com.ibm.pb.decorations.MashupSkinItems.prototype._switchToSkin,
		_switchToSkin: function(skinId, widgetId){
			var fn = this._mashupsSwitchToSkin(skinId, widgetId);
			return function() {
				var wa = com.ibm.pb.contextMenu.sharedActions.getWidgetAccessor(widgetId);
				var state = wa.getWindowState();
				if (state == wa.MAX) {
					var metadata = new Object();
					metadata.newWindowState ="normal";
					metadata.event = com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE;
					com.ibm.pb.contextMenu.sharedActions.changeWindowState(widgetId, null, metadata, null);
					var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
					com.ibm.themes.bspaceTheme.delayedMaximize = widgetId;
					com.ibm.themes.bspaceTheme.delayedMaxmizeSub = evtSvc.subscribeEvent("com.ibm.mashups.builder.layoutRefreshed", com.ibm.themes.bspaceTheme, 'performDelayedMaximize');
				}
				fn();
			}
		}
	});
	// defect 83416: selection stops working on IE after edit mode
	//
	// When running on Internet Explorer, the dojo drag/drop code
	// steals the mouse and selection events to detect drag start
	// actions.  This logic, though, prevents selection from working
	// within a drag/drop container.  Dojo provides a partial fix
	// for this with the skipForm flag that tells a container to 
	// skip drag/drop processing if the source of the event is a
	// form control (button, textarea, input, etc.)  The following
	// "fix" modifies the Dojo drag/drop code to also skip processing
	// for any element within a widget's body area (as long as it is
	// not within a drag/drop container within the widget).  The
	// code is from IBM Dojo 1.6.1 (20110519) version. If using a
	// newer version of Dojo, this code may need to be updated.
	if (dojo.isIE) {
		dojo.extend(dojo.dnd.Source, {
			onMouseDown: function(e){
				if(!this.mouseDown && this._legalMouseDown(e) && (!this.skipForm || !dojo.dnd.isFormElement(e))){
					// start of defect 83416 addition
					var node = e.target;
					while (node && !dojo.hasClass(node,'dojoDndSource')) {
						if (dojo.hasClass(node,'lotusWidgetBody')) {
							return;
						}
						node = node.parentNode;
					}
					// end of defect 83416 addition
					this.mouseDown = true;
					this._lastX = e.pageX;
					this._lastY = e.pageY;
					dojo.dnd.Source.superclass.onMouseDown.call(this, e);
				}
			},
			onSelectStart: function(e){
				if(!this.skipForm || !dojo.dnd.isFormElement(e)){
					// start of defect 83416 addition
					var node = e.target;
					while (node && !dojo.hasClass(node,'dojoDndSource')) {
						if (dojo.hasClass(node,'lotusWidgetBody')) {
							return;
						}
						node = node.parentNode;
					}
					// end of defect 83416 addition
					dojo.stopEvent(e);
				}
			}
		});
	}	
}

// APAR JR45517
if (dojo.cookie.isSupported()) {
	// Replace CookieManager commit function with a no-op to prevent
	// mashups from writing the digest.ignore.state.<userid> cookie
	com.ibm.mashups.enabler.model.state.CookieManager.commit = function() {
	}
	// If the cookie already exists (from a previous version), remove it
	if (dojo.cookie(com.ibm.mashups.enabler.model.state.CookieManager._getCookieID())) {
		var opts = { expires: -1 };
		if (!dojo.isIE) {
			opts.path = com.ibm.mashups.enabler.model.state.CookieManager.cookiePath;
		} 
		dojo.cookie(com.ibm.mashups.enabler.model.state.CookieManager._getCookieID(),null,opts);
	}
}
