/* Licensed Materials - Property of IBM.
(c) Copyright IBM Corporation 2001, 2009.  All Rights Reserved.
U.S. Government Users Restricted Rights:  Use, duplication or
disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */

if(!dojo._hasResource["lconn.core.TypeAhead"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["lconn.core.TypeAhead"] = true;
/* ***************************************************************** */
/*                                                                   */
/* Licensed Materials - Property of IBM.                             */
/*                                                                   */
/* (c) Copyright IBM Corporation 2001, 2009.  All Rights Reserved.   */
/*                                                                   */
/* U.S. Government Users Restricted Rights:  Use, duplication or     */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*                                                                   */
/* ***************************************************************** */
dojo.provide("lconn.core.TypeAhead");

dojo.require("dijit.form.ComboBox");

dojo.declare(
    "lconn.core.TypeAhead",    [dijit.form.ComboBox],
    {
        // emailAttr: string
        //      The e-mail address will come from this field
        emailAttr: '',
        
        // nameAttr: string
        //      The name will come from this field
        nameAttr: '',
        
        // emailTokenOpen: string
        // emailTokenClose: string
        //      These will be placed around the e-mail address, so a person will appear like this:
        //      John Q. Doe (johnqdoe@domain.com) if the tokens are ( and ). 
        //      E-mail addresses are ignored if emailAttr is not set.
        emailTokenOpen: '<',
        emailTokenClose: '>',
        
        // minChars: number
        //      The number of characters that need to be typed before doing a search
        minChars: 1,
        
        hasDownArrow: false,
        
        //multipleValues: bool
        //      Sets whether or not this type-ahead should support multiple values.
        //      If true, then typing a token (usually comma) will cause the type-ahead
        //      to reset and begin searching for a new name. 
        multipleValues: true,
        
        // token: string
        //      The character to split all the names by in the text box.
        //      Only used if multipleValues is true.
        token: ',',
        
        escapeText: function (text) {
            var tmp = document.createElement("div");
            tmp.appendChild(document.createTextNode(text));
            var escaped = tmp.innerHTML;
            
            return escaped;
        },
        
        onkeypress: function(/*Event*/ evt){
            // summary: handles keyboard events

            //except for pasting case - ctrl + v(118)
            if(evt.altKey || (evt.ctrlKey && evt.charCode != 118)){
                return;
            }
            var doSearch = false;
            this.item = null; // #4872
            if(this._isShowingNow){this._popupWidget.handleKey(evt);}
            switch(evt.keyCode){
                case dojo.keys.PAGE_DOWN:
                case dojo.keys.DOWN_ARROW:
                    if(!this._isShowingNow||this._prev_key_esc){
                        this._arrowPressed();
                        doSearch=true;
                    }else{
                        //this._announceOption(this._popupWidget.getHighlightedOption());
                    }
                    dojo.stopEvent(evt);
                    this._prev_key_backspace = false;
                    this._prev_key_esc = false;
                    break;

                case dojo.keys.PAGE_UP:
                case dojo.keys.UP_ARROW:
                    if(this._isShowingNow){
                        //this._announceOption(this._popupWidget.getHighlightedOption());
                    }
                    dojo.stopEvent(evt);
                    this._prev_key_backspace = false;
                    this._prev_key_esc = false;
                    break;

                case dojo.keys.ENTER:
                    // prevent submitting form if user presses enter
                    // also prevent accepting the value if either Next or Previous are selected
                    var highlighted;
                    if(this._isShowingNow&&(highlighted=this._popupWidget.getHighlightedOption())){
                        // only stop event on prev/next
                        if(highlighted==this._popupWidget.nextButton){
                            this._nextSearch(1);
                            dojo.stopEvent(evt);
                            break;
                        }
                        else if(highlighted==this._popupWidget.previousButton){
                            this._nextSearch(-1);
                            dojo.stopEvent(evt);
                            break;
                        }
                        else if(parseInt(highlighted.item.type) < 0) {
                            dojo.stopEvent(evt);
                            break;
                        }
                    }else{
                        //Used for autocomplete
                        this.setDisplayedValue(this.getDisplayedValue());
                    }
                    // default case:
                    // prevent submit, but allow event to bubble
                    evt.preventDefault();
                    // fall through

                case dojo.keys.TAB:
                    var newvalue=this.getDisplayedValue();
                    // #4617: if the user had More Choices selected fall into the _onBlur handler
                    if(this._popupWidget &&
                        (newvalue == this._popupWidget._messages["previousMessage"] ||
                            newvalue == this._popupWidget._messages["nextMessage"])){
                        break;
                    }
                    if(this._isShowingNow){
                        this._prev_key_backspace = false;
                        this._prev_key_esc = false;
                        if(this._popupWidget.getHighlightedOption()){
                            this._popupWidget.setValue({target:this._popupWidget.getHighlightedOption()}, true);
                        }
                        this._hideResultList();
                    }
                    break;

                case dojo.keys.SPACE:
                    this._prev_key_backspace = false;
                    this._prev_key_esc = false;
                    if(this._isShowingNow && this._popupWidget.getHighlightedOption()){
                        dojo.stopEvent(evt);
                        this._selectOption();
                        this._hideResultList();
                    }else{
                        doSearch = true;
                    }
                    break;

                case dojo.keys.ESCAPE:
                    this._prev_key_backspace = false;
                    this._prev_key_esc = true;
                    this._hideResultList();
                    if(this._lastDisplayedValue != this.getDisplayedValue()){
                        this.setDisplayedValue(this._lastDisplayedValue);
                        dojo.stopEvent(evt);
                    }else{
                        this.setValue(this.getValue(), false);
                    }
                    break;

                case dojo.keys.DELETE:
                case dojo.keys.BACKSPACE:
                    this._prev_key_esc = false;
                    this._prev_key_backspace = true;
                    doSearch = true;
                    break;

                case dojo.keys.RIGHT_ARROW: // fall through

                case dojo.keys.LEFT_ARROW: // fall through
                    this._prev_key_backspace = false;
                    this._prev_key_esc = false;
                    break;

                default:// non char keys (F1-F12 etc..)  shouldn't open list
                    this._prev_key_backspace = false;
                    this._prev_key_esc = false;
                    if(dojo.isIE || evt.charCode != 0){
                        doSearch=true;
                    }
            }
            if(this.searchTimer){
                clearTimeout(this.searchTimer);
            }
            if(doSearch){
                // need to wait a tad before start search so that the event bubbles through DOM and we have value visible
                this.searchTimer = setTimeout(dojo.hitch(this, this._startSearchFromInput), this.searchDelay);
            }
        },

        _openResultList: function(/*Object*/ results, /*Object*/ dataObject){
            if(this.disabled || dataObject.query != this._lastQuery){
                return;
            }
            this._popupWidget.clearResultList();
            if(!results.length){
                this._hideResultList();
                return;
            }
            
            //add Search Directory button
            //results.push({name: this.rs_searchDirectory, type: -1});
            
            this._popupWidget.createOptions(results, dataObject, dojo.hitch(this, this._getMenuLabelFromItem));

            // show our list (only if we have content, else nothing)
            this._showResultList();
            
            this._popupWidget.highlightFirstOption();
            
            //If the first result doesn't have an e-mail, then it's not one we want to highlight.
            //  So, highlight the next one.
            if(parseInt(results[0].type) == -1)
                this._popupWidget._highlightNextOption();

            // #4091: tell the screen reader that the paging callback finished by shouting the next choice
            if(dataObject.direction){
                if(dataObject.direction==1){
                    this._popupWidget.highlightFirstOption();
                }else if(dataObject.direction==-1){
                    this._popupWidget.highlightLastOption();
                }
                this._announceOption(this._popupWidget.getHighlightedOption());
            }
        },

        _doSelect: function(tgt){
            if(parseInt(tgt.item.type) == -1)
                return;
            
            var newValue = this.store.getValue(tgt.item, this.nameAttr);
            
            if(this.emailAttr && tgt.item[this.emailAttr])
                newValue += ' ' + this.emailTokenOpen + this.store.getValue(tgt.item, this.emailAttr) + this.emailTokenClose;
            
            if(this.multipleValues) {
                var oldValue = this.nameArr[this.nameIdx];
                
                this.nameArr[this.nameIdx] = (this.nameIdx != 0 ? ' ' : '') + newValue;
                
                newValue = this.nameArr.join(this.token);
                if(newValue.length >= this.token.length+1 && newValue.substring(newValue.length-this.token.length-1) != this.token + ' ')
                    newValue += this.token + ' ';
            }
            else {
                this.item = tgt.item;
            }
            
            this.setValue(newValue, true);
            this._setCaretPos(this.focusNode, newValue.length);
        },

        _startSearchFromInput: function(){
            //We need to split the string by "," and then do a search on the name 
            //  where the cursor currently resides
            var currentInput = this.focusNode.value;
            var searchString = currentInput;
            
            if(this.multipleValues) {
                this.nameArr = currentInput.split(this.token);
                this.caretPos = this._getCaretPos(this.focusNode);
                //The index associated with the name in nameArr which is currently being typed
                //  is equal to the number of ',' preceding the cursor.
                this.nameIdx = 0;
                for(var i=0; i<this.caretPos; i++) {
                    if(currentInput[i] == this.token)
                        this.nameIdx++;
                }
            
                searchString = this.nameArr[this.nameIdx];
                console.log(this.nameArr);
                console.log(searchString);
            }
                
            //Trim white-space from the beginning and end of searchString
            searchString = this.trim(searchString);
            
            //Only search if the searchString is at least minChars long
            if(searchString.length >= this.minChars)
                this._startSearch(searchString);
            else
                this._hideResultList();
        },
        
        trim: function(str) {
            return str.replace(/^\s*/, "").replace(/\s*$/, "");
        },

        _startSearch: function(/*String*/ key, /* bool */ searchDirectory){
            if(!this._popupWidget){
                this._popupWidget = new dijit.form._ComboBoxMenu({
                    onChange: dojo.hitch(this, this._selectOption)
                });
            }
            
            if(searchDirectory == undefined) searchDirectory = false;
            
            // create a new query to prevent accidentally querying for a hidden value from FilteringSelect's keyField
            var query=this.query;
            this._lastQuery=query=key;
            
            var dataObject=this.store.fetch({
                queryOptions: {
                    ignoreCase:this.ignoreCase, 
                    deep:true
                }, 
                searchDirectory: searchDirectory,
                query: query, 
                onComplete:dojo.hitch(this, "_openResultList"), 
                start:0, 
                count:this.pageSize
            });
            
            function nextSearch(dataObject, direction){
                dataObject.start+=dataObject.count*direction;
                // #4091: tell callback the direction of the paging so the screen reader knows which menu option to shout
                dataObject.direction=direction;
                dataObject.store.fetch(dataObject);
            }
            this._nextSearch=this._popupWidget.onPage=dojo.hitch(this, nextSearch, dataObject);
            this._popupWidget.searchDirectory=dojo.hitch(this, dojo.hitch(this, function() {
                this._startSearch(key, true);
            }));
        },
        
        getAttribute: function(/* string */ attr) {
            if(this.item && this.item[attr])
                return this.item[attr];
            else
                return '';
        },
        
        //Get the real value in the text box
        getTextBoxValue: function () {
            return this.focusNode.value;
        },
        
        _getMenuLabelFromItem:function(/*Item*/ item){
            if(!this.emailAttr || !item[this.emailAttr])
                return {html: false, label: item[this.nameAttr]};
                
            //label = [name, email]
            var label =      [this.escapeText(item[this.nameAttr]), this.escapeText(item[this.emailAttr])];
            var labelLower = [label[0].toLowerCase(),               label[1].toLowerCase()               ];
            
            var key = '';
            
            if(this.multipleValues)
                key = this.trim(this.nameArr[this.nameIdx]);
            else
                key = this.trim(this.focusNode.value);
                
            var keyLower = key.toLowerCase();
            
            var startIdx = 0;
            var match = null;
            
            //Add <b> tags to the label in places where it matches the search key
            for(var i=0; i<2; i++) {
                startIdx = 0;
                
                while(key && -1 < (match = labelLower[i].indexOf(keyLower, startIdx))){
                    label[i] = label[i].substr(0, match) 
                              + '<b>' + label[i].substring(match, match + key.length) + '</b>' 
                              + label[i].substring(match + key.length);
                    startIdx = match + key.length + 7; //<b></b> is 7 characters
                    labelLower[i] = label[i].toLowerCase();
                }
            }
            
            return {html: true, label: label[0] + ' ' + this.escapeText(this.emailTokenOpen) + label[1] + this.escapeText(this.emailTokenClose) };
        }
    }
);

}
