/* Licensed Materials - Property of IBM.
(c) Copyright IBM Corporation 2001, 2009.  All Rights Reserved.
U.S. Government Users Restricted Rights:  Use, duplication or
disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */

if(!dojo._hasResource["lconn.core.TypeAheadStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["lconn.core.TypeAheadStore"] = true;
/* ***************************************************************** */
/*                                                                   */
/* Licensed Materials - Property of IBM.                             */
/*                                                                   */
/* (c) Copyright IBM Corporation 2001, 2009.  All Rights Reserved.   */
/*                                                                   */
/* U.S. Government Users Restricted Rights:  Use, duplication or     */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*                                                                   */
/* ***************************************************************** */
dojo.provide("lconn.core.TypeAheadStore");

dojo.declare("lconn.core.TypeAheadStore", null, {
    constructor: function(/* Object */ keywordParameters, node){
        this.queryParam = (keywordParameters.queryParam ? 
                           keywordParameters.queryParam : node.getAttribute("queryParam"));
        
        this.url = (keywordParameters.url ?
                    keywordParameters.url : node.getAttribute("url"));

    },
    
    // queryParam: string
    //      The search attribute for getting JSON
    //      The store will be queried like this:
    //      url?queryParam=query
    queryParam: '',
    
    // searchDirectory: bool
    //      Whether or not we should search the directory
    searchDirectory: false,
    
    cache: [],
    dirCache: [],
     
        //      { 
        //          query: query-string or query-object,
        //          queryOptions: object,
        //          onBegin: Function,
        //          onItem: Function,
        //          onComplete: Function,
        //          onError: Function,
        //          scope: object,
        //          start: int
        //          count: int
        //          sort: array
        //          searchDirectory: bool
        //      }
    fetch: function(keywordArgs) {
        var params = {};
        var cache;
        
        this.searchDirectory = (keywordArgs.searchDirectory ? true : false);
        
        if(this.searchDirectory)
            cache = this.dirCache;
        else
            cache = this.cache;
            
        if(cache[keywordArgs.query.toLowerCase()]) {
            //Todo: In this case, we run onComplete before returning, unlike the other case.
            //      Is this a problem?
            keywordArgs.onComplete(cache[keywordArgs.query.toLowerCase()], keywordArgs);
            return keywordArgs;
        }
        
        if(this.queryParam)
            params[this.queryParam] = keywordArgs.query;
        if(this.searchDirectory)
            params.usedirectory = 'yes';
            
        dojo.xhrGet({
            url: this.url,
            content: params, 
            handleAs: "json-comment-optional",
            load: dojo.hitch(this, function(data) {
                //TODO: Keep cache in check?
                var cache;
                if(this.searchDirectory)
                    cache = this.dirCache;
                else
                    cache = this.cache;
                    
                cache[keywordArgs.query.toLowerCase()] = data.items;
                if(keywordArgs.onComplete)
                    keywordArgs.onComplete(data.items, keywordArgs);
            }),
            error: function() {
                console.log("There was an error");
            }
        });
        
        return keywordArgs;
    },
    
    getValue: function(item, attribute, defaultValue) {
        if (item[attribute])
            return item[attribute];
        else
            return defaultValue;
    }
});

}
