/*! Licensed Materials - Property of IBM.
    (c) Copyright IBM Corporation 2001, 2009.  All Rights Reserved.
    U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
This JavaScript was built on April 30 2010. (version: OneUI-2.1.0_149_20100430-1512)*/

/* This file contains the functions needed for the documentation. */


/* ***************************************************************** */
/*                                                                   */
/* Licensed Materials - Property of IBM.                             */
/*                                                                   */
/* (c) Copyright IBM Corporation 2001, 2009.  All Rights Reserved.   */
/*                                                                   */
/* U.S. Government Users Restricted Rights:  Use, duplication or     */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*                                                                   */
/* ***************************************************************** */

/* This JavaScript was built on April 30 2010. (version: OneUI-2.1.0_149_20100430-1512) */

/* This JavaScript file contains utility methods used by the documentation. */

/*
	The code in this file is provided for the purpose of enabling the documentation
	to function or to illustrate all the various behaviors/visuals of a component.  
	This code is not intended to serve as a widget library and it is not supported.
*/

// Define the DevDoc class constructor
function DevDoc () {

	// Setup to manage onload handlers
	this.onLoadHandlers = new Array();
	if (null != window.onload) {
		this.onLoadHandlers.push(window.onload);
	}
	// We cannot just do this:  window.onload = this.onLoadHandler;
	// because doing that here can be broken by a <body onload=""> handler.
	// So, we use the DOM event mechanism to hook in.
	this.addEvent(window, "load", this.onLoadHandler, true);

	// setup default selected tab in component pages
	this.componentPageSelectedTab="tab1";

	// setup a list of iframes for the resize handler
	this.iframeResizeIds = new Array();

	// We cannot just do this:  window.onload = this.iframeResizeHandler;
	// because doing that here can be broken by a <body onload=""> handler.
	// So, we use the DOM event mechanism to hook in.
	// this.addEvent(window, "load", this.iframeResizeHandler, true);

}

// onLoad handler to process our hooks to onload.
// NOTE: because this function is called by the DOM event system,
// the "this" pointer is not necessarily what you think it is.
// So you have to refer to the devdoc singleton object instance
// in the global namespace to get to the collection of handlers instead of writing:
// 		this.onLoadHandlers[x]();
DevDoc.prototype.onLoadHandler = function (loadevt) {
    var crossevt=(window.event)? event : loadevt
	for(var x = 0; x < devdoc.onLoadHandlers.length; x++){	// must use "devdoc" global instead of "this" here.
		devdoc.onLoadHandlers[x](crossevt);					// must use "devdoc" global instead of "this" here.
	}
}



// Adds to the list of onload handlers... The Dojo way.
// Note that we attach to onload differently than Dojo so unlike Dojo,
// this method is compatible with <body onload=""> being in the HTML.
//
//	devdoc.addOnLoad(functionPointer);
//	devdoc.addOnLoad(object, "functionName");
//	devdoc.addOnLoad(object, function(){ /* ... */});
//
// We do it this way because the DOM eventing model can attach a method to an object,
// but not a specific method on a specific target object.  This means inside the target
// method, the "this" pointer is not always what you expect.
//
// By attaching on load handlers through this method, we keep track of the specific
// instance on the target so when the target method is called, "this" referrs to 
// the right instance.
DevDoc.prototype.addOnLoad = function( obj, fn ) {
	if(!fn){
		this.onLoadHandlers.push(obj);
	}else if(fn){
		var func = (typeof fn == "string") ? obj[fn] : fn;
		this.onLoadHandlers.push(function(){ func.call(obj); });
	}
}

// A generic method to add callback functions to the DOM event model
// Use of this method is discouraged because the "this" pointer in
// the target method isn't always what you think it is.
DevDoc.prototype.addEvent = function (obj, eventType, fn, useCapture){
	if (obj.addEventListener){
		obj.addEventListener(eventType, fn, useCapture);
		return true;
	} else if (obj.attachEvent){
		var rc = obj.attachEvent("on"+eventType, fn);
		return rc;
	}
}



// Function to parse the query parameters on the URL and return an associative array of strings
DevDoc.prototype.parseQueryParameters = function(query) {
	var queryParameters = new Array();
	var parms = query.split('&');
	for (var i=0; i<parms.length; i++) {
		var pos = parms[i].indexOf('=');
		if (pos > 0) {
			var key = decodeURIComponent(parms[i].substring(0,pos));
			var val = decodeURIComponent(parms[i].substring(pos+1));
			// alert("key="+key+" val="+val);
			queryParameters[key] = val;
		}
	}
	return queryParameters;
}

// Function to show a tab in a components page
DevDoc.prototype.showComponentTab = function (tabId){
	document.getElementById(this.componentPageSelectedTab).className="";
	document.getElementById(this.componentPageSelectedTab+"content").style.display="none";
	document.getElementById(tabId).className="selected";
	document.getElementById(tabId+"content").style.display="block";
	if (tabId == "tab1") {
		document.getElementById("componentsToolbar").style.display="block";
	} else {
		document.getElementById("componentsToolbar").style.display="none";
	}
	this.componentPageSelectedTab=tabId;

	return false; // stops event processing and prevents href from being executed on anchor link
}

// Function to select a new theme
DevDoc.prototype.selectTheme = function (selectObject){
	var path = window.location.href.split("?")[0];
	var newTheme = selectObject.options[selectObject.selectedIndex].value;
	if ("default" == newTheme) {
		newTheme = null;
	}
	var newQS = this.urlStateManager.computeQueryString("theme", newTheme);
	if (newQS.length > 0) {
		newQS = "?" + newQS;
	}
	var url = path + newQS;
	window.location.href = url;

	return false; // stops event processing and prevents href from being executed on anchor link
}

DevDoc.prototype.pseudoLanguageList = { "en":"English", "p_latin1":"Simulated Latin1 Short", "p_latin1long":"Simulated Latin1 Long", "p_ru":"Simulated Russian", "p_el":"Simulated Greek", "p_ar":"Simulated Arabic", "p_iw":"Simulated Hebrew", "p_ja":"Simulated Japanese", "p_ko":"Simulated Korean", "p_zh":"Simulated S. Chinese", "p_zh_TW":"Simulated T. Chinese", "p_th":"Simulated Thai" };

// Function to select a new pseudo language
DevDoc.prototype.selectPseudoLanguage = function (selectObject){
	var path = window.location.href.split("?")[0];
	var newPseudoLanguage = selectObject.options[selectObject.selectedIndex].value;
	var newDirectionality = null;
	if ("en" == newPseudoLanguage) {
		newPseudoLanguage = null;
	}
	if ("p_iw" == newPseudoLanguage || "p_ar" == newPseudoLanguage) {
		newDirectionality = "rtl";
	}

	var newQS = this.urlStateManager.computeQueryString("plang", newPseudoLanguage, "dir", newDirectionality);
	if (newQS.length > 0) {
		newQS = "?" + newQS;
	}
	var url = path + newQS;
	window.location.href = url;

	return false; // stops event processing and prevents href from being executed on anchor link
}

// Function to select a new directionality
DevDoc.prototype.selectRtlDirectionality = function (bRtlDir){
	var path = window.location.href.split("?")[0];
	var newDir = null;
	if (bRtlDir) {
		newDir = "rtl";
	}
	var newQS = this.urlStateManager.computeQueryString("dir", newDir);
	if (newQS.length > 0) {
		newQS = "?" + newQS;
	}
	var url = path + newQS;
	window.location.href = url;

	return false; // stops event processing and prevents href from being executed on anchor link
}

// Function to select a new state for lotusImagesOff
DevDoc.prototype.selectForceLotusImagesOff = function (bForce){
	var path = window.location.href.split("?")[0];
	var newForce = null;
	if (bForce) {
		newForce = "true";
	}
	var newQS = this.urlStateManager.computeQueryString("imagesOff", newForce);
	if (newQS.length > 0) {
		newQS = "?" + newQS;
	}
	var url = path + newQS;
	window.location.href = url;

	return false; // stops event processing and prevents href from being executed on anchor link
}

// Function to select a new theme
/*
DevDoc.prototype.initThemeChooser = function (){
	// select proper option
	var theme = this.urlStateManager.getTheme();
	var sel = document.getElementById("themeChooser");
	for (var i=0; i < sel.options.length; i++) {
		if (theme == sel.options[i].value) {
			sel.selectedIndex = i;
			break;
		}
	}
}
*/

// Function to resize an iframe to be the size of its contents
DevDoc.prototype.resizeIframe = function (iframe) {
	if (iframe && !window.opera){
		var doc = null;
		var height = 0;

		// cross-browser access to body of iframe
		if (iframe.contentDocument) {
			// Mozilla/Firefox
			doc = iframe.contentDocument;
			height = doc.body.offsetHeight;
		} else if (iframe.Document) {
			// IE
			doc = iframe.Document;
			height = doc.body.scrollHeight;
		}

/*
		// Check all children of the body tag to see if any of them are position:absolute
		// and if they are taller than the height we already have
		for (i=0; i < doc.body.childNodes.length; i++) {
			var node = doc.body.childNodes[i];
			if (node instanceof ) {
				alert(node.toString() + " " + devdoc.getComputedStyle(doc, node, "overflow"));
			}
		}
*/
		// escape hatch - use this to keep the iframe from getting to small.
		// This happens when there is nothing but position:absolute stuff on the page
		if (height < 10) {
			height = 200;
			//iframe.style.borderColor = "#f00";
			//iframe.style.borderWidth = "1px";
			//iframe.style.borderStyle = "solid";
		}

		// Add in some extra padding
		height += 40;

		// Set the height
		iframe.style.height = height+"px";

	}

}

// Function to get the computed style of an element
DevDoc.prototype.getComputedStyle = function(doc, element, stylename) {
	var computedStyle;
	if (typeof element.currentStyle != "undefined") {
		computedStyle = element.currentStyle;
	} else {
		computedStyle = doc.defaultView.getComputedStyle(element, null);
	}
	return computedStyle[stylename];
}

// Function to add an iframe to the list of iframes that are resized when appropriate
DevDoc.prototype.addIframeToSizeHandler = function (iframeId) {
	this.iframeResizeIds.push(iframeId);
	var iframe = document.getElementById(iframeId);
	this.addEvent(iframe, "load", this.iframeResizeHandler, true);
	//this.addEvent(iframe.document, "click", this.iframeResizeHandler, true);
}

// Function to handle resizing iframes when an event fires
DevDoc.prototype.iframeResizeHandler = function (loadevt) {
    var crossevt=(window.event)? event : loadevt;
	var iframe=(crossevt.currentTarget)? crossevt.currentTarget : crossevt.srcElement;
	if (iframe) {
		// alert(iframe.id);
		devdoc.resizeIframe(iframe);
	}
}

// Function to handle common onload stuff for all documentation pages (Except example iframe contents)
DevDoc.prototype.commonDocumentationOnloadProcessing = function (pathToRoot) {

	// Instantiate the url state manager and navigation selection manager
	devdoc.urlStateManager = new UrlStateManager();

	if ("alpha"==devdoc.urlStateManager.getTheme()) {
		alert("The 'alpha' theme is now the default theme.  Please update your bookmarks.");
		var path = window.location.href.split("?")[0];
		var newQS = devdoc.urlStateManager.computeQueryString("theme", null);
		if (newQS.length > 0) {
			newQS = "?" + newQS;
		}
		var url = path + newQS;
		window.location.href = url;
	} else {
		devdoc.navigationSelectionManager = new NavigationSelectionManager(pathToRoot);
		devdoc.addOnLoad(devdoc.navigationSelectionManager, "updateNavigationSelection");
		devdoc.addOnLoad(devdoc.urlStateManager, "addUrlStateToLinks");
	}
}

// Function to handle common onload stuff for documentation example pages in IFRAMEs
DevDoc.prototype.commonDocumentationOnloadProcessingForExampleIFrames = function (imagesPath) {
	// Create a UrlStateManager
	devdoc.urlStateManager = new UrlStateManager();
	devdoc.imagesPath = imagesPath;
//	devdoc.addOnLoad(devdoc, "highContrastTest");
	devdoc.addOnLoad(devdoc, "checkPseudoTranslate");
	devdoc.addOnLoad(devdoc, "checkForceLotusImagesOff");
}

// Function to force lotusImagesOff when the onload event fires and the <body> tag is accessible.
DevDoc.prototype.checkForceLotusImagesOff = function() {
	if (devdoc.urlStateManager.isForceLotusImagesOff()) {
		document.getElementsByTagName("body")[0].className+=" lotusImagesOff";
	}
}

// Function to perform pseudo translation
DevDoc.prototype.checkPseudoTranslate = function () {
	var pseudoLanguage = devdoc.urlStateManager.getPseudoLanguage();
	if ("p_ja" == pseudoLanguage ) {
		document.getElementsByTagName("body")[0].className+=" lotusJapanese";
	}
	if ("en" != pseudoLanguage) {
		devdoc_newCharactersPos=0;
		devdoc.pseudoTranslate(document.body, pseudoLanguage);
	}
}

DevDoc.prototype.pseudoTranslate = function (node, pseudoLanguage) {
	// alert(pseudoLanguage);

	var i;
	if (node.childNodes.length > 0) {
		for (i=0; i < node.childNodes.length; i++) {
			devdoc.pseudoTranslate(node.childNodes[i], pseudoLanguage);
		}
	} else if (node.nodeName == "#text") {
		node.nodeValue = devdoc.pseudoTranslateText(node.nodeValue, pseudoLanguage);
	} else if (node.nodeName == "INPUT") {
		node.value = devdoc.pseudoTranslateText(node.value, pseudoLanguage);
	}

	// process attributes
	if (null != node.attributes && node.attributes.length > 0) {
		for (i=0; i < node.attributes.length; i++) {
			if ( (node.attributes[i].nodeName == "title") || (node.attributes[i].nodeName == "alt") ) {
				node.attributes[i].nodeValue = devdoc.pseudoTranslateText(node.attributes[i].nodeValue, pseudoLanguage);
			}
		}
	}
}

DevDoc.prototype.pseudoTranslateText = function (text, pseudoLanguage) {
	var trimmedText = devdoc.trim(text); // trim is null-safe and returns null if null is passed

	// use a special wider space if the pseudo language is Latin1
	// We cannot do this with a unicode em or en space because those show up as box symbols in IE 6.
	var space = " ";
	if ( ("p_latin1" == pseudoLanguage) || ("p_latin1long" == pseudoLanguage) ) {
		space = "\u00a0\u00a0 ";  // \u00a0 is a non-breaking space (&nbsp;)  We put two of them in to give the width we want and then a regular space so wordbreak can happen.
	}

	// Don't pseudo-translate a single piece of text that is a single letter "X".
	// This is to simulate a real product that wouldn't translate this accessibility character for "close".
	if (null != text && trimmedText.length > 0 && "X" != trimmedText) {
		var words = text.split(" ");
		var i;
		for (i=0; i < words.length; i++) {
			words[i] = ((devdoc.pseudoTranslators[pseudoLanguage])(words[i]));
		}
		newtext = words.join(space);
	} else {
		newtext = text;
	}
	return newtext;
}

var devdoc_newCharactersPos = 0;

DevDoc.prototype.hebrewAlphabet = "\u05D0\u05D1\u05D2\u05D3\u05D4\u05D5\u05D6\u05D7\u05D8\u05D9\u05DA\u05DB\u05DC\u05DD\u05DE\u05DF\u05E0\u05E1\u05E2\u05E3\u05E4\u05E5\u05E6\u05E7\u05E8\u05E9\u05EA"
DevDoc.prototype.arabicAlphabet = "\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A"
//DevDoc.prototype.cyrillicAlphabet = "\u0401\u0402\u0403\u0404\u0405\u0406\u0407\u0408\u0409\u040A\u040B\u040C\u040E\u040F\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u0451\u0452\u0453\u0454\u0455\u0456\u0457\u0458\u0459\u045A\u045B\u045C\u045E\u045F";
DevDoc.prototype.russianAlphabet = "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F";
DevDoc.prototype.greekAlphabet = "\u0391\u0392\u0393\u0394\u0395\u0396\u0397\u0398\u0399\u039A\u039B\u039C\u039D\u039E\u039F\u03A0\u03A1\u03A3\u03A4\u03A5\u03A6\u03A7\u03A8\u03A9\u03B1\u03B2\u03B3\u03B4\u03B5\u03B6\u03B7\u03B8\u03B9\u03BA\u03BB\u03BC\u03BD\u03BE\u03BF\u03C0\u03C1\u03C3\u03C4\u03C5\u03C6\u03C7\u03C8\u03C9";

//DevDoc.prototype.koreanCharacters = "\uD55C\uAE00";
//DevDoc.prototype.koreanCharacters = "\uc0c8\uc2a4\ud0c0\uc77c\uc774\ub984\uc744\uc785\ub825\ud558\uc2ed\uc2dc\uc624\uae30\ubcf8\uc124\uc815\uc744\uc0ac\uc6a9\ud558\uac70\ub098\uae30\uc874\uc124\uc815\uc744\ubcf5\uc0ac\ud558\uc5ec\uc0c8\uc2a4\ud0c0\uc77c\uc744\uc791\uc131\ud560\uc218\uc788\uc2b5\ub2c8\ub2e4\ud604\uc7ac\uc2a4\ud0c0\uc77c\uc744\ud3b8\uc9d1\uc911\uc778\uacbd\uc6b0\uc800\uc7a5\ud558\uc9c0\uc54a\uc740\ubcc0\uacbd\uc0ac\ud56d\uc774\ubaa8\ub450\ubc84\ub824\uc9d1\ub2c8\ub2e4";
DevDoc.prototype.koreanCharacters = "\uc0c8\uc2a4\ud0c0\uc77c\uc774\ub984\uc744\uc785\ub825\ud558\uc2ed\uc2dc\uc624\uae30\ubcf8\uc124\uc815\uc744\uc0ac\uc6a9\ud558\uac70\ub098\uae30\uc874\uc124\uc815\uc744\ubcf5\uc0ac\ud558\uc5ec\uc0c8\uc2a4\ud0c0\uc77c\uc744\uc791\uc131\ud560\uc218\uc788\uc2b5\ub2c8\ub2e4\ud604\uc7ac\uc2a4\ud0c0\uc77c\uc744\ud3b8\uc9d1\uc911\uc778\uacbd\uc6b0\uc800\uc7a5\ud558\uc9c0\uc54a\uc740\ubcc0\uacbd\uc0ac\ud56d\uc774\ubaa8\ub450\ubc84\ub824\uc9d1\ub2c8\ub2e4";

//DevDoc.prototype.simplifiedChineseCharacters = "\u8f93\u5165\u65b0\u6837\u5f0f\u7684\u540d\u79f0\u60a8\u53ef\u4ee5\u4f7f\u7528\u7f3a\u7701\u8bbe\u7f6e\u6765\u521b\u5efa\u65b0\u6837\u5f0f\u6216\u8005\u590d\u5236\u73b0\u6709\u6837\u5f0f\u5982\u679c\u60a8\u5f53\u524d\u6b63\u5728\u7f16\u8f91\u6837\u5f0f\u4efb\u4f55\u672a\u4fdd\u5b58\u7684\u66f4\u6539\u5c06\u88ab\u653e\u5f03";
//DevDoc.prototype.simplifiedChineseCharacters = "\u8bf7\u8bbf\u95ee\u7f51\u7ad9\u4ee5\u83b7\u5f97\u66f4\u591a\u4fe1\u606f\u9700\u83b7\u5f97\u66f4\u591a\u5e2e\u52a9\u8bf7\u8054\u7cfb\u5ba2\u6237\u670d\u52a1\u4ee3\u8868";
DevDoc.prototype.simplifiedChineseCharacters = [ "\u6708\u4eae", "\u6cb3", "\u8def", "\u5929", "\u5730", "\u4eba", "\u623f\u5b50", "\u6c34" ];

//DevDoc.prototype.traditionalChineseCharacters = "\u8acb\u8f38\u5165\u65b0\u6a23\u5f0f\u7684\u540d\u7a31\u60a8\u53ef\u4ee5\u5229\u7528\u9810\u8a2d\u503c\u4f86\u5efa\u7acb\u65b0\u6a23\u5f0f\u6216\u8907\u88fd\u73fe\u6709\u7684\u6a23\u5f0f\u5982\u679c\u60a8\u76ee\u524d\u5728\u7de8\u8f2f\u67d0\u500b\u6a23\u5f0f\u4efb\u4f55\u672a\u5132\u5b58\u7684\u8b8a\u66f4\u90fd\u6703\u88ab\u6368\u68c4";
//DevDoc.prototype.traditionalChineseCharacters = "\u8acb\u9020\u8a2a\u7db2\u7ad9\u4ee5\u7372\u53d6\u66f4\u591a\u7684\u8cc7\u8a0a\u9700\u53d6\u5f97\u66f4\u591a\u7684\u5e6b\u52a9\u8acb\u8207\u5ba2\u6236\u4ee3\u8868\u806f\u7d61";
DevDoc.prototype.traditionalChineseCharacters = [ "\u70cf\u9f9c", "\u9f8d\u821f", "\u592a\u967d", "\u96fb\u8a71", "\u98db\u6a5f", "\u9b06\u9905", "\u7b46\u8a18\u672c", "\u66f8\u7c64", "\u7f50\u982d" ];

//DevDoc.prototype.japaneseCharacters = "\u8868\u7AF9\uFF5E";
//DevDoc.prototype.japaneseCharacters = "\u65b0\u898f\u30b9\u30bf\u30a4\u30eb\u306e\u540d\u524d\u3092\u5165\u529b\u3057\u307e\u3059\u30c7\u30d5\u30a9\u30eb\u30c8\u8a2d\u5b9a\u3092\u4f7f\u7528\u3057\u3066\u65b0\u898f\u30b9\u30bf\u30a4\u30eb\u3092\u4f5c\u6210\u3059\u308b\u304b\u3001\u65e2\u5b58\u306e\u30b9\u30bf\u30a4\u30eb\u3092\u30b3\u30d4\u30fc\u3067\u304d\u307e\u3059\u30b9\u30bf\u30a4\u30eb\u3092\u7de8\u96c6\u3057\u3066\u3044\u308b\u5834\u5408\u3001\u4fdd\u7ba1\u3057\u3066\u3044\u306a\u3044\u5909\u66f4\u306f\u7834\u68c4\u3055\u308c\u307e\u3059";
//DevDoc.prototype.japaneseCharacters = [ "\u30d5\u30a9\u30fc", "\u30e0", "\u306b", "\u30e6\u30fc", "\u30b6\u30fc", "\u304c", "\u8868", "\u793a", "\u53ef", "\u80fd", "\u307e", "\u305f", "\u306f", "\u7de8", "\u96c6", "\u53ef", "\u80fd", "\u306a", "\u30c7\u30fc", "\u30bf", "\u3092", "\u542b", "\u3080", "\u4e00", "\u3064", "\u4ee5", "\u4e0a", "\u306e", "\u30bf", "\u30d6", "\u304c", "\u3042", "\u308b", "\u3053", "\u3068", "\u3092", "\u78ba", "\u8a8d", "\u3057", "\u3066", "\u304f", "\u3060", "\u3055", "\u3044" ];
DevDoc.prototype.japaneseCharacters = [ "\u30d5\u30a9\u30fc", "\u30e0", "\u306b", "\u30e6\u30fc", "\u30b6\u30fc", "\u304c", "\u8868", "\u793a", "\u53ef", "\u80fd", "\u307e", "\u305f", "\u306f", "\u7de8", "\u96c6", "\u53ef", "\u80fd", "\u306a", "\u30c7\u30fc", "\u30bf", "\u3092", "\u542b", "\u3080", "\u4e00", "\u3064", "\u4ee5", "\u4e0a", "\u306e", "\u30bf", "\u30d6", "\u304c", "\u3042", "\u308b", "\u3053", "\u3068", "\u3092", "\u78ba", "\u8a8d", "\u3057", "\u307e", "\u3059" ];

//DevDoc.prototype.thaiCharacters = "\u0E2C\u0E0F\u0E5B";
//DevDoc.prototype.thaiCharacters = "\u0e1b\u0e49\u0e2d\u0e19\u0e0a\u0e37\u0e48\u0e2d\u0e2a\u0e33\u0e2b\u0e23\u0e31\u0e1a\u0e25\u0e31\u0e01\u0e29\u0e13\u0e30\u0e43\u0e2b\u0e21\u0e48\u0e04\u0e38\u0e13\u0e2a\u0e32\u0e21\u0e32\u0e23\u0e16\u0e2a\u0e23\u0e49\u0e32\u0e07\u0e25\u0e31\u0e01\u0e29\u0e13\u0e30\u0e43\u0e2b\u0e21\u0e48\u0e42\u0e14\u0e22\u0e43\u0e0a\u0e49\u0e04\u0e48\u0e32\u0e15\u0e34\u0e14\u0e15\u0e31\u0e49\u0e07\u0e14\u0e35\u0e1f\u0e2d\u0e25\u0e15\u0e4c\u0e2b\u0e23\u0e37\u0e2d\u0e04\u0e31\u0e14\u0e25\u0e2d\u0e01\u0e25\u0e31\u0e01\u0e29\u0e13\u0e30\u0e17\u0e35\u0e48\u0e21\u0e35\u0e2d\u0e22\u0e39\u0e48\u0e16\u0e49\u0e32\u0e04\u0e38\u0e13\u0e01\u0e33\u0e25\u0e31\u0e07\u0e41\u0e01\u0e49\u0e44\u0e02\u0e25\u0e31\u0e01\u0e29\u0e13\u0e30\u0e2d\u0e22\u0e39\u0e48\u0e01\u0e32\u0e23\u0e40\u0e1b\u0e25\u0e35\u0e48\u0e22\u0e19\u0e41\u0e1b\u0e25\u0e07\u0e17\u0e35\u0e48\u0e44\u0e21\u0e48\u0e44\u0e14\u0e49\u0e1a\u0e31\u0e19\u0e17\u0e36\u0e01\u0e08\u0e30\u0e16\u0e39\u0e01\u0e25\u0e30\u0e40\u0e27\u0e49\u0e19";
DevDoc.prototype.thaiCharacters = [ "\u0e01\u0e34\u0e48", "\u0e02\u0e38\u0e48", "\u0e03\u0e35\u0e4b", "\u0e04\u0e34\u0e48", "\u0e05\u0e38\u0e4c", "\u0e06\u0e35\u0e4a", "\u0e07\u0e36\u0e4a", "\u0e08\u0e36\u0e48", "\u0e09\u0e35\u0e4c", "\u0e0a\u0e38\u0e49", "\u0e0b\u0e39\u0e4b", "\u0e0c\u0e34\u0e4c", "\u0e0d\u0e34\u0e4c", "\u0e0d\u0e39\u0e4b", "\u0e0e\u0e38\u0e4c", "\u0e0f\u0e39\u0e4c", "\u0e10\u0e34\u0e4c", "\u0e10\u0e38\u0e4c", "\u0e11\u0e34\u0e4c", "\u0e12\u0e39\u0e4a", "\u0e13\u0e34\u0e4a", "\u0e14\u0e35\u0e4c", "\u0e15\u0e34\u0e4c", "\u0e16\u0e38\u0e4c", "\u0e17\u0e3a\u0e4c", "\u0e18\u0e49\u0e33", "\u0e19\u0e34\u0e4c", "\u0e1a\u0e38\u0e4c", "\u0e1b\u0e34\u0e4c", "\u0e1c\u0e38\u0e4a", "\u0e1d\u0e34\u0e4c", "\u0e1e\u0e4a\u0e33", "\u0e1f\u0e34\u0e4a", "\u0e20\u0e47\u0e34", "\u0e21\u0e31\u0e49", "\u0e22\u0e4d\u0e4c", "\u0e23\u0e38\u0e4c", "\u0e24\u0e39\u0e4c", "\u0e25\u0e4a\u0e33", "\u0e26\u0e39\u0e4c", "\u0e27\u0e34\u0e4a", "\u0e28\u0e36\u0e4c", "\u0e29\u0e3a\u0e4d", "\u0e2a\u0e39\u0e4c", "\u0e2b\u0e36\u0e4c", "\u0e2c\u0e34\u0e4a", "\u0e2d\u0e39\u0e4c", "\u0e2e\u0e34\u0e4a" ];


DevDoc.prototype.pseudoTranslators = {

	"p_latin1": function (text) {
		return DevDoc.prototype.pseudoTranslators["p_latin"](text, "\u25e6");
	},

	"p_latin1long": function (text) {
		// for latin1long, we use 2 spacer characters instead of one
		return DevDoc.prototype.pseudoTranslators["p_latin"](text, "\u25e6\u25e6");
	},

	"p_latin": function (text, spacer) {

		var newtext = "";
		if (devdoc.trim(text).length > 0) {
			var i;
			var c;
			for (i=0; i < text.length; i++) {
				c = text.substring(i,i+1);
				newtext = newtext + c;

				// expand the length of the word by adding characters
				if ( ("A" <= c && c <= "Z") || ("a" <= c && c <= "z") ) {
					if ((i+1) < text.length)  {
						var nextc = text.substring(i+1,i+2);
					if ( ("A" <= nextc && nextc <= "Z") || ("a" <= nextc && nextc <= "z") ) {
							newtext = newtext + spacer;
						}
					}
				}
			}
			newtext = newtext.replace(/a/g, "\u00E0");
			newtext = newtext.replace(/A/g, "\u0102");
			newtext = newtext.replace(/e/g, "\u00E9");
			newtext = newtext.replace(/o/g, "\u00F4");
			newtext = newtext.replace(/u/g, "\u00FC");
			newtext = newtext.replace(/n/g, "\u00F1");
			newtext = newtext.replace(/C/g, "\u00c7");
			newtext = newtext.replace(/c/g, "\u00e7");
			newtext = newtext.replace(/s/g, "\u0161");
			newtext = newtext.replace(/S/g, "\u0160");
		} else {
			newtext = text;
		}
	
		return newtext;
	},

	"p_ar": function (text) {
		 var newtext = devdoc.pseudoTranslateCharacterReplace(text,devdoc.arabicAlphabet); 		 
		 newtext = newtext.replace(/\?/g, "\u061f"); // convert question mark to arabic question mark
		 newtext = newtext.replace(/,/g, "\u060C");	// convert comma to arabic comma
		 newtext = newtext.replace(/;/g, "\u061B");	// convert semi-colon to arabic semi-colon
		 return newtext;
	},

	"p_ru": function (text) {
		 return devdoc.pseudoTranslateCharacterReplace(text,devdoc.russianAlphabet); 
	},

	"p_el": function (text) {
		 var newtext = devdoc.pseudoTranslateCharacterReplace(text,devdoc.greekAlphabet); 
		 newtext = newtext.replace(/\?/g, "\u037E"); // convert question mark to greek question mark
		 return newtext;
	},

	"p_iw": function (text) {
		 return devdoc.pseudoTranslateCharacterReplace(text,devdoc.hebrewAlphabet); 
	},

	"p_ja": function (text) {
		 var newtext = devdoc.pseudoTranslateCharacterReplace(text,devdoc.japaneseCharacters); 
		 newtext = newtext.replace(/\./g, "\u3002"); // convert period to full stop
		 newtext = newtext.replace(/\u3002\u3002/g, ".."); // ellipsis fix: convert double full stop back to double period
		 newtext = newtext.replace(/\.\u3002/g, ".."); // ellipsis fix: convert period followed by full stop back to double period
		 newtext = newtext.replace(/\u3002\./g, ".."); // ellipsis fix: convert full stop followed by period back to double period
		 newtext = newtext.replace(/,/g,  "\u3001"); // convert comma to ideographic comma
		 // Japanese does not use full width exclamation or question marks
		 return newtext;
	},

	"p_ko": function (text) {
		 return devdoc.pseudoTranslateCharacterReplace(text,devdoc.koreanCharacters); 
	},

	"p_zh": function (text) {
		 var newtext = devdoc.pseudoTranslateCharacterReplace(text,devdoc.simplifiedChineseCharacters);
		 newtext = newtext.replace(/\./g, "\u3002"); // convert period to full stop
		 newtext = newtext.replace(/\u3002\u3002/g, ".."); // ellipsis fix: convert double full stop back to double period
		 newtext = newtext.replace(/\.\u3002/g, ".."); // ellipsis fix: convert period followed by full stop back to double period
		 newtext = newtext.replace(/\u3002\./g, ".."); // ellipsis fix: convert full stop followed by period back to double period
		 newtext = newtext.replace(/,/g,  "\uff0c"); // convert comma to full width comma
		 newtext = newtext.replace(/\!/g, "\uff01"); // convert exclamation to full width exclamation
		 newtext = newtext.replace(/\?/g, "\uff1f"); // convert question mark to full width question mark
		 return newtext;
	},

	"p_zh_TW": function (text) {
		 var newtext = devdoc.pseudoTranslateCharacterReplaceSkip(text,devdoc.traditionalChineseCharacters,2);
		 newtext = newtext.replace(/\./g, "\u3002"); // convert period to full stop
		 newtext = newtext.replace(/\u3002\u3002/g, ".."); // ellipsis fix: convert double full stop back to double period
		 newtext = newtext.replace(/\.\u3002/g, ".."); // ellipsis fix: convert period followed by full stop back to double period
		 newtext = newtext.replace(/\u3002\./g, ".."); // ellipsis fix: convert full stop followed by period back to double period
		 newtext = newtext.replace(/,/g,  "\uff0c"); // convert comma to full width comma
		 newtext = newtext.replace(/\!/g, "\uff01"); // convert exclamation to full width exclamation
		 newtext = newtext.replace(/\?/g, "\uff1f"); // convert question mark to full width question mark
		 return newtext;
	},

	"p_th": function (text) {
		 return devdoc.pseudoTranslateCharacterReplace(text,devdoc.thaiCharacters); 
	}

}

DevDoc.prototype.pseudoTranslateCharacterReplace = function (text, newCharacters) {
	return devdoc.pseudoTranslateCharacterReplaceSkip(text, newCharacters, 0);
}

DevDoc.prototype.pseudoTranslateCharacterReplaceSkip = function (text, newCharacters, skip) {
	var newtext = "";
	var i;
	var c;
	for (i=0; i < text.length; i++) {
		c = text.substring(i,i+1);
		if ( ("A" <= c && c <= "Z") || ("a" <= c && c <= "z") ) {
			if ( (skip == 0) || (skip > 0 && i % skip == 0) ) {
				if (devdoc_newCharactersPos >= newCharacters.length) {
					devdoc_newCharactersPos = 0;
				}
				var translatedChars;
				if (newCharacters instanceof Array) {
					translatedChars = newCharacters[devdoc_newCharactersPos];
				} else {
					translatedChars = newCharacters.substring(devdoc_newCharactersPos, devdoc_newCharactersPos+1);
				}
				newtext = newtext + translatedChars;
				devdoc_newCharactersPos++;
			}
		} else {
			newtext = newtext + c;
		}
	}
	return newtext;
}

DevDoc.prototype.trim = function (text) {
	var newStr = null;
	if (null != text) {
		newStr = text.replace(/^\s*([\S\s]*?)\s*$/, '$1');
	}
    return newStr;
}


// Function to check for high contrast/images off mode
DevDoc.prototype.highContrastTest = function (){
	//create test case element
	var imagesPath = devdoc.imagesPath;
	var vTestHC = document.createElement("div");
	vTestHC.id = "testHC";
	vTestHC.style.cssText = 'border: 1px solid;'
            + 'border-color:red green;'
            + 'position: absolute;'
            + 'height: 5px;'
            + 'top: -999px;'
            + 'background-image: url("' + imagesPath + '/blank.gif");';
	document.body.appendChild(vTestHC);

	//do the tests
	var vTestHC = document.getElementById("testHC");
	var vStyle = null;
	try{
		vStyle = document.defaultView.getComputedStyle(vTestHC, "");
	}catch(e){
		vStyle = vTestHC.currentStyle;
	}
	var vTestImg = vStyle.backgroundImage;
	if ((vStyle.borderTopColor==vStyle.borderRightColor) || (vTestImg != null && (vTestImg == "none" || vTestImg == "url(invalid-url:)" ))){
		document.getElementsByTagName("body")[0].className+=" lotusImagesOff";
		//alert("high contrast turned on");
	}
}


// Function to write out the collection of guideline links
DevDoc.prototype.writeGuidelineLinks = function (guidelineList) {
	document.write("<div class='internal'>");
	document.write("<h3>See IBM Internal Guidelines:</h3><ul>");
	var i = 0;
	var len = guidelineList.length
	while (i < len) {
		var key = guidelineList[i];
		var title = "";
		i++;
		if (i < len) {
			title = guidelineList[i];
		}
		i++;
		document.write("<li><a class='external' href='https://w3.tap.ibm.com/w3ki08/"+key+"' target='_blank'>" + title + "</a></li>");
	}
	document.write("</ul>");
	document.write("</div>");
}

// Define the DevDoc singleton
var devdoc = new DevDoc();

/* ***************************************************************** */
/*                                                                   */
/* Licensed Materials - Property of IBM.                             */
/*                                                                   */
/* (c) Copyright IBM Corporation 2001, 2009.  All Rights Reserved.   */
/*                                                                   */
/* U.S. Government Users Restricted Rights:  Use, duplication or     */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*                                                                   */
/* ***************************************************************** */

/* This JavaScript was built on April 30 2010. (version: OneUI-2.1.0_149_20100430-1512) */

/* This JavaScript file contains the NavigationSelectionManager class. */

/*
	The code in this file is provided for the purpose of enabling the documentation
	to function or to illustrate all the various behaviors/visuals of a component.  
	This code is not intended to serve as a widget library and it is not supported.
*/

// Define the NavigationSelectionManager class constructor
function NavigationSelectionManager (pathToRoot) {
	this.pathToRoot = pathToRoot;
}

/*
	Function to select the correct tab/page in the top and side navigations.
	Selection is based upon the name of the file at the end of the URL and
	the subfolder in which that file is located or a parameter on the URL.
	
	In general, this routine searches through all of the navigation links looking
	at the anchor tags to find a match for the address in the address bar.
*/
NavigationSelectionManager.prototype.updateNavigationSelection = function() {
	var pathname = location.pathname.replace(/\\/g,"/");
	var pathParts = pathname.split("/");
	var filename = pathParts[pathParts.length-1];
	var sectionDir = pathParts[pathParts.length-2];
	var contentParameter = devdoc.urlStateManager.getParameterValue("content");
	var queryStringIncludes = "content="+contentParameter;

	//alert("["+pathToRoot+"]["+sectionDir+"]["+filename+"]["+contentParameter+"]");

	// Figure out the item to select in the top navigation.
	var topNavListItemToSelect = null;
	if ("."==this.pathToRoot) {
		// when pathToRoot = "." a file at the root of the website is selected
		topNavListItemToSelect = this.findSelectionInNavSet("topnav", filename);
	} else {
		// select the topnav element based upon the name of the section.  The ID of top nav elements must be "topnav_<sectionname>".
		topNavListItemToSelect = document.getElementById("topnav_"+sectionDir);
	}
	if (null != topNavListItemToSelect) {
		topNavListItemToSelect.className += " selected";
	}

	// Figure out the item to select in the side navigation
	var sideNavListItemToSelect = null;
	if ( ! ("." == this.pathToRoot && "examples.htm" == filename && null == contentParameter) ) {
		sideNavListItemToSelect = this.findSelectionInNavSet("sidenav", filename, queryStringIncludes);
	}
	if (null != sideNavListItemToSelect) {
		sideNavListItemToSelect.className += " selected";
	}
}

/*
	Locates the list item that needs to be selected in a navigation set.
	Navigation sets have the id navBaseID, navBaseID+"2", navBaseID+"3", etc.
	eg: topnav, sidenav, sidenav2, sidenav3, etc.
*/
NavigationSelectionManager.prototype.findSelectionInNavSet = function(navBaseID, findFilename, queryStringIncludes) {
	var listItemToSelect = null;

	// Loop through navigation sets and search for the selected item in each one.
	var i = 1;
	var nav = document.getElementById(navBaseID);
	while (null == listItemToSelect && null != nav) {
		listItemToSelect = this.findSelectionInNav(nav, findFilename, queryStringIncludes);

		// check for next navigation
		i++;
		nav = document.getElementById(navBaseID+i)
	}

	return listItemToSelect;
}

/*
	Locates the list item that needs to be selected in a given navigation.
	This algorithm searches through all anchor links for an href attribute that matches.
	Then it returns the parent LI element for that anchor link.
*/
NavigationSelectionManager.prototype.findSelectionInNav = function(nav, findFilename, queryStringIncludes) {
	var listItemToSelect = null;

	var anchorArray = nav.getElementsByTagName('A');
	for (i=0; i<anchorArray.length; i++) {

		// Get the href and split it up for processing
		var href = anchorArray[i].href;
		var hrefParts = href.split("?");
		var path = hrefParts[0];
		var queryString = (hrefParts.length > 1) ? hrefParts[1] : null;
		var pathParts = path.split("/");
		var filename = pathParts[pathParts.length-1];
		var sectionDir = pathParts[pathParts.length-2];

		// If there is no filename, just select the first link in the list
		if (filename==findFilename || 0==findFilename.length) {
			if (null != queryStringIncludes && null != queryString) {
				if (queryString.indexOf(queryStringIncludes) >= 0) {
					// We found a query string that includes the string we're looking for. Find the parent LI item and return it.
					listItemToSelect = this.findParentTagNamed(anchorArray[i], "LI");
					break;
				}
			} else {
				// If there is no string to search in the query string, find the parent LI item and return it.
				listItemToSelect = this.findParentTagNamed(anchorArray[i], "LI");
				break;
			}
		}
	}

	return listItemToSelect;
}

/*
	Locates a parent tag with a given name
*/
NavigationSelectionManager.prototype.findParentTagNamed = function(node, tagName) {
	var p = node.parentNode;
	while (null != p && tagName != p.tagName) {
		p = p.parentNode;
	}
	return p;
}

/* ***************************************************************** */
/*                                                                   */
/* Licensed Materials - Property of IBM.                             */
/*                                                                   */
/* (c) Copyright IBM Corporation 2001, 2009.  All Rights Reserved.   */
/*                                                                   */
/* U.S. Government Users Restricted Rights:  Use, duplication or     */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*                                                                   */
/* ***************************************************************** */

/* This JavaScript was built on April 30 2010. (version: OneUI-2.1.0_149_20100430-1512) */

/* This JavaScript file contains the UrlStateManager class. */

/*
	The code in this file is provided for the purpose of enabling the documentation
	to function or to illustrate all the various behaviors/visuals of a component.  
	This code is not intended to serve as a widget library and it is not supported.
*/

// Define the UrlStateManager class constructor that parses the query string
function UrlStateManager () {
	var queryString = window.location.search.substring(1);
	// alert("window.location.search="+window.location.search);
	this.queryParameters = devdoc.parseQueryParameters(queryString);
}


// Method to compute a query string optionally modifying one of the values
UrlStateManager.prototype.computeQueryString = function(changeKey, newValue, changeKey2, newValue2) {
	var qs = "";
	var changeKeyFound = false;
	var changeKey2Found = false;
	for (var key in this.queryParameters) {
		var val = this.queryParameters[key];
		if (null != changeKey && key == changeKey) {
			val = newValue;
			changeKeyFound = true;
		}
		if (null != changeKey2 && key == changeKey2) {
			val = newValue2;
			changeKey2Found = true;
		}

		// Only add the parameter if it is not null
		if (null != val) {
			if (qs.length > 0) {
				qs += "&";
			}
			qs += encodeURIComponent(key) + "=" + encodeURIComponent(val);
		}
	}

	// add the change key if it didn't exist and neither it nor its value are null
	if (null != changeKey && null != newValue && !changeKeyFound) {
		if (qs.length > 0) {
			qs += "&";
		}
		qs += encodeURIComponent(changeKey) + "=" + encodeURIComponent(newValue);
	}
	if (null != changeKey2 && null != newValue2 && !changeKey2Found) {
		if (qs.length > 0) {
			qs += "&";
		}
		qs += encodeURIComponent(changeKey2) + "=" + encodeURIComponent(newValue2);
	}

	return qs;
}

// Debug method to dump all query string parameters
UrlStateManager.prototype.dumpParameters = function() {
	alert(this.computeQueryString());
}

// Method to get the value of a parameter optionally passing in a default value
UrlStateManager.prototype.getParameterValue = function(key, defaultValue) {
	var val = this.queryParameters[key];
	if (null == val) {
		val = defaultValue;
	}
	return val;
}

// Method to return the RTL state
UrlStateManager.prototype.isRTL = function() {
	var isRTL = false;
	var val = this.queryParameters["dir"];
	if (null != val && "rtl" == val.toLowerCase()) {
		isRTL = true;
	}
	return isRTL;
}

// Method to return the string "RTL" when dir=rtl
// and an empty string when dir=ltr
UrlStateManager.prototype.getRTL = function() {
	var rc = "";
	if (this.isRTL()) {
		rc = "RTL";
	}
	return rc;
}

// Method to return the force lotusImagesOff state
UrlStateManager.prototype.isForceLotusImagesOff = function() {
	var isForce = false;
	var val = this.queryParameters["imagesOff"];
	if (null != val && "true" == val.toLowerCase()) {
		isForce = true;
	}
	return isForce;
}

// Method to return the name of the current theme
UrlStateManager.prototype.getTheme = function() {
	return this.getParameterValue("theme", "default");
}

// Method to return the name of the current language for pseudo-translation
UrlStateManager.prototype.getPseudoLanguage = function() {
	return this.getParameterValue("plang", "en");
}

// Method to update URLs on the page to include the current URL state
UrlStateManager.prototype.addUrlStateToLinks = function() {

	// Process anchor links
	var anchorArray = document.getElementsByTagName('A');
	for (i=0; i<anchorArray.length; i++) {

		// Do not process links with the class of "external"
		// Do not process links that have "javascript:" in the href attribute
		if ( (anchorArray[i].className.indexOf("external") < 0) && (anchorArray[i].href.indexOf("javascript:") < 0) ) {
			var propagateContentParameter = false;
			if (anchorArray[i].className.indexOf("propagateContentParameter") >= 0) {
				propagateContentParameter = true;
			}
			var newUrl = this.addStateToUrl(anchorArray[i].href, propagateContentParameter);
			// alert("newUrl="+newUrl);
			anchorArray[i].href = newUrl;
		}
	}

}

// Method to update a single URL to include the current URL state
// Returns the new URL
UrlStateManager.prototype.addStateToUrl = function(url, propagateContentParameter) {
	var newUrl = url;

	// compute the list of parameters on the current URL
	var urlParameters = new Array();
	var queryStringIndex = url.indexOf("?");
	if (queryStringIndex > 0) {
		// alert("qs="+url.substring(queryStringIndex+1));
		var urlParameters = devdoc.parseQueryParameters(url.substring(queryStringIndex+1))				
	}

	// Now append the parameters from the browser URL that are NOT already in the existing url
	// Do not propogate the "content" key from the browser URL to this URL unless we specifically request to do so.
	for (var key in this.queryParameters) {
		if (!urlParameters[key] && (propagateContentParameter || "content" != key) ) {
			if (queryStringIndex < 0) {
				queryStringIndex = newUrl.length; // update queryStringIndex so we don't put too may ? characters on the URL.
				newUrl += "?";
			} else {
				newUrl += "&";
			}
			newUrl += encodeURIComponent(key) + "=" + encodeURIComponent(this.queryParameters[key]);
		}
	}

	return newUrl;
}

